/*

qbombAI.js

Priority-based AI for quirium cascade mines

Oolite
Copyright © 2004-2013 Giles C Williams and contributors

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA 02110-1301, USA.

*/

"use strict";

this.name = "Oolite Q-bomb AI";

this.$initialise = function() {
		//log(this.name, "starting the cascadeExplosion !");
		this.ship.broadcastCascadeImminent();
		this.explosion = new Timer(this,function() {
				this.ship.becomeCascadeExplosion();
		},5);
		this.init = true;
}

this.shipSpawned = function() {
		var s = this.ship.owner;
		//if (s) log(this.name, "Q-bomb - shipSpawned by "+ s.name);

		if (s && !s.isPlayer) {
			if (!this.init) {
				if (s.isDerelict) return;
				
				this.$initialise();
			}
		} else log(this.name, "Q-bomb - shipSpawned by ( null | player | spawnOne | system.addShips )");
}

this.shipWasDumped = function() {
		var s = this.ship.owner;
		//if (s) log(this.name, "Q-bomb - shipWasDumped by "+ s.name);

		// don't need a priority AI for this one
		if (!this.init) this.$initialise();
}

this.shipDied = function() {
		if (this.init) this.explosion.stop();
}
